# List products

Returns a dictionary with a data property that contains an array of products, starting after the cursor, if used. Each entry in the array is a separate product object. If no more products are available, the resulting array will be empty. This request should never return an error.

Endpoint: GET /products
Version: 2025-11-12
Security: bearerAuth

## Query parameters:

  - `cursor` (string)
    A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with next_page=W3sib3JkZXJ=, your subsequent call can include cursor=W3sib3JkZXJ= in order to fetch the next page of the list.

  - `expand[]` (array)
    Allows you to expand responses by including related object information in a single call. See the Expand responses section of the Quickstart API Tutorials for detailed instructions.

  - `filter[]` (array)
    A case-sensitive filter on the list. See the Filter lists section of the Quickstart API Tutorials for detailed instructions.

  - `sort[]` (array)
    A case-sensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. account_number.asc) or descending (e.g. account_number.desc). You cannot sort on properties that are arrays. If the array-type properties are specified for the sort[] parameter, they are ignored.

  - `page_size` (integer)
    The maximum number of results to return in a single page. If the specified page_size is less than 1 or greater than 99, Zuora will return a 400 error.

  - `fields[]` (array)
    Allows you to specify which fields are returned in the response. 
         
           Accepted values  
            custom_fields, created_by_id, updated_by_id, created_time, id, updated_time, start_date, end_date, active, name, type, sku, description
    Example: ["id,created_time"]

  - `plans.fields[]` (array)
    Allows you to specify which fields are returned in the response. 
         
           Accepted values  
            custom_fields, created_by_id, updated_by_id, created_time, id, updated_time, start_date, end_date, name, active, description, plan_number, product_id, active_currencies
    Example: ["id,created_time"]

  - `prices.fields[]` (array)
    Allows you to specify which fields are returned in the response. 
         
           Accepted values  
            custom_fields, created_by_id, updated_by_id, created_time, id, updated_time, tiers, charge_model, charge_type, name, description, revenue_recognition_rule, stacked_discount, recognized_revenue_accounting_code, deferred_revenue_accounting_code, accounting_code, recurring, start_event, tax_code, tax_inclusive, taxable, unit_of_measure, quantity, min_quantity, max_quantity, price_base_interval, discount_level, overage, plan_id, tiers_mode, apply_discount_to, prepayment, drawdown, discount_amounts, unit_amounts, discount_percent, amounts, price_change_percentage, price_change_option, price_increase_option
    Example: ["id,created_time"]

  - `product.fields[]` (array)
    Allows you to specify which fields are returned in the response. 
         
           Accepted values  
            custom_fields, created_by_id, updated_by_id, created_time, id, updated_time, start_date, end_date, active, name, type, sku, description
    Example: ["id,created_time"]

## Header parameters:

  - `zuora-track-id` (string)
    A custom identifier for tracking API requests. If you set a value for this header, Zuora returns the same value in the response header. This header enables you to track your API calls to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), or quote (').

  - `async` (boolean)
    Making asynchronous requests allows you to scale your applications more efficiently by leveraging Zuora's infrastructure to enqueue and execute requests for you without blocking. These requests also use built-in retry semantics, which makes them much less likely to fail for non-deterministic reasons, even in extreme high-throughput scenarios. Meanwhile, when you send a request to one of these endpoints, you can expect to receive a response in less than 150 milliseconds and these calls are unlikely to trigger rate limit errors. If set to true, Zuora returns a 202 Accepted response, and the response body contains only a request ID.

  - `zuora-entity-ids` (string)
    An entity ID. If you have Multi-entity enabled and the authorization token is valid for more than one entity, you must use this header to specify which entity to perform the operation on. If the authorization token is only valid for a single entity or you do not have Multi-entity enabled, you do not need to set this header.

  - `idempotency-key` (string)
    Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. This idempotency key should be a unique value, and the Zuora server identifies subsequent retries of the same request using this value. For more information, see Idempotent Requests.

  - `accept-encoding` (string)
    Include a accept-encoding: gzip header to compress responses, which can reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes. For more information about this header, see Request and Response Compression.

  - `content-encoding` (string)
    Include a content-encoding: gzip header to compress a request. Upload a gzipped file for the payload if you specify this header. For more information, see Request and Response Compression.

  - `zuora-org-ids` (string)
    Comma separated IDs. If you have Zuora Multi-Org enabled,
you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails.

If the header is not set, the operation is performed in scope of the user's accessible orgs.

## Response 200 fields (application/json):

  - `next_page` (string,null)

  - `data` (array)

  - `data.id` (string)
    Unique identifier for the object.

  - `data.updated_by_id` (string)
    Unique identifier of the Zuora user who last updated the object

  - `data.updated_time` (string)
    The date and time when the object was last updated in ISO 8601 UTC format.

  - `data.created_by_id` (string)
    Unique identifier of the Zuora user who created the object

  - `data.created_time` (string)
    The date and time when the object was created in ISO 8601 UTC format.

  - `data.custom_fields` (object)
    Set of user-defined fields associated with this object. Useful for storing additional information about the object in a structured format.

  - `data.custom_objects` (object)
    The custom objects associated with a Zuora standard object.

  - `data.start_date` (string)
    The date from which the product can be used for new purchases.

  - `data.end_date` (string)
    The date on which the product can no longer be used for new purchases.

  - `data.name` (string)
    The name of the product.

  - `data.type` (string)
    The type of product.
    Enum: "base", "add_on", "other"

  - `data.sku` (string)
    The sku identifier of the product.

  - `data.description` (string)
    An arbitrary string attached to the object. Often useful for displaying to users.

  - `data.active` (boolean)
    Whether the product can be used for new purchases.

  - `data.plans` (object)
    A list of plans.

  - `data.plans.next_page` (string,null)

  - `data.plans.data` (array)

  - `data.plans.data.id` (string)
    Unique identifier for the object.

  - `data.plans.data.updated_by_id` (string)
    Unique identifier of the Zuora user who last updated the object

  - `data.plans.data.updated_time` (string)
    The date and time when the object was last updated in ISO 8601 UTC format.

  - `data.plans.data.created_by_id` (string)
    Unique identifier of the Zuora user who created the object

  - `data.plans.data.created_time` (string)
    The date and time when the object was created in ISO 8601 UTC format.

  - `data.plans.data.custom_fields` (object)
    Set of user-defined fields associated with this object. Useful for storing additional information about the object in a structured format.

  - `data.plans.data.custom_objects` (object)
    The custom objects associated with a Zuora standard object.

  - `data.plans.data.start_date` (string)
    The date from which the plan can be used for new purchases.

  - `data.plans.data.end_date` (string)
    The date on which the plan can no longer be used for new purchases.

  - `data.plans.data.name` (string)
    The name of the plan.

  - `data.plans.data.plan_number` (string)
    Human-readable identifier of the plan. It can be user-supplied.

  - `data.plans.data.description` (string)
    An arbitrary string attached to the object. Often useful for displaying to users.

  - `data.plans.data.active_currencies` (array)
    A list of 3-letter ISO-standard currency codes representing active currencies for the plan.

  - `data.plans.data.product_id` (string)
    Identifier of the product associated with this plan.

  - `data.plans.data.active` (boolean)
    Whether the plan can be used for new purchases.

  - `data.plans.data.product` (object)
    The product associated with this plan.

  - `data.plans.data.sku` (string)
    The product sku. This field is only availble for customers using high speed cache.

  - `data.plans.data.prices` (object)
    A list of prices.

  - `data.plans.data.prices.next_page` (string,null)

  - `data.plans.data.prices.data` (array)

  - `data.plans.data.prices.data.id` (string)
    Unique identifier for the object.

  - `data.plans.data.prices.data.updated_by_id` (string)
    Unique identifier of the Zuora user who last updated the object

  - `data.plans.data.prices.data.updated_time` (string)
    The date and time when the object was last updated in ISO 8601 UTC format.

  - `data.plans.data.prices.data.created_by_id` (string)
    Unique identifier of the Zuora user who created the object

  - `data.plans.data.prices.data.created_time` (string)
    The date and time when the object was created in ISO 8601 UTC format.

  - `data.plans.data.prices.data.custom_fields` (object)
    Set of user-defined fields associated with this object. Useful for storing additional information about the object in a structured format.

  - `data.plans.data.prices.data.custom_objects` (object)
    The custom objects associated with a Zuora standard object.

  - `data.plans.data.prices.data.name` (string)
    The name of the price.

  - `data.plans.data.prices.data.description` (string)
    An arbitrary string attached to the object. Often useful for displaying to users.

  - `data.plans.data.prices.data.recognized_revenue_accounting_code` (string)
    An active accounting code in your Zuora chart of accounts.

  - `data.plans.data.prices.data.deferred_revenue_accounting_code` (string)
    An active accounting code in your Zuora chart of accounts.

  - `data.plans.data.prices.data.recurring` (object)
    The recurring components of a price such as interval and usage.

  - `data.plans.data.prices.data.start_event` (string)
    Specifies when to start billing your customer.
    Enum: "contract_effective", "service_activation", "customer_acceptance", "specific_date"

  - `data.plans.data.prices.data.apply_discount_to` (array)
    Any combination of one_time, recurring and plan.
    Enum: "one_time", "recurring", "usage"

  - `data.plans.data.prices.data.tiers` (array)
    Price information for different tiers. When creating or updating tiered prices, you must specify this field and the tiers_mode field.

  - `data.plans.data.prices.data.tax_code` (string)
    A tax code identifier. If a tax_code of a price is not provided when you create or update a price, Zuora will treat the charged amount as non-taxable. If this code is provide, Zuora considers that this price is taxable and the charged amount will be handled accordingly.

  - `data.plans.data.prices.data.tax_inclusive` (boolean)
    If this field is set to true, it indicates that amounts are inclusive of tax.

  - `data.plans.data.prices.data.unit_of_measure` (string)
    A configured unit of measure. This field is required for per-unit prices.

  - `data.plans.data.prices.data.quantity` (number)
    Quantity of the product to which your customers subscribe.

  - `data.plans.data.prices.data.min_quantity` (number)
    The minimum quantity for a price. Specify this field and the max_quantity field to create a range of quantities allowed in a price.

  - `data.plans.data.prices.data.max_quantity` (number)
    The maximum quantity for a price. Specify this field and the min_quantity field to create a range of quantities allowed in a price.

  - `data.plans.data.prices.data.discount_level` (string)
    Specifies at what level a discount should be applied: account, subscription, or plan.
    Enum: "account", "subscription", "plan"

  - `data.plans.data.prices.data.revenue_recognition_rule` (string)
    Determines when to recognize the revenue for this charge. You can choose to recognize upon invoicing or daily over time.

  - `data.plans.data.prices.data.stacked_discount` (boolean)
    This field is only applicable for the Percentage Discount price. This field indicates whether the discount is to be calculated as stacked discount. Possible values are as follows:               true: This is a stacked discount, which should be calculated by stacking with other discounts.        false: This is not a stacked discount, which should be calculated in sequence with other discounts. For more information, see Stacked discounts

  - `data.plans.data.prices.data.amounts` (object)
    Example: {"USD":10,"GBP":15}

  - `data.plans.data.prices.data.unit_amounts` (object)
    Example: {"USD":10,"GBP":15}

  - `data.plans.data.prices.data.discount_amounts` (object)
    Example: {"USD":10,"GBP":15}

  - `data.plans.data.prices.data.discount_percent` (number)
    Discount percent. Specify this field if you offer a percentage-based discount.

  - `data.plans.data.prices.data.price_base_interval` (string)
    Specifies the base interval of a price. If not provided, this field defaults to billing_period.
    Enum: "month", "billing_period", "week"

  - `data.plans.data.prices.data.revenue` (object)
    Accounting configuration if you have Zuora Revenue enabled.

  - `data.plans.data.prices.data.accounting_code` (string)
    An active accounting code defined in Finance Settings > Configure Accounting Codes in your Zuora tenant.

  - `data.plans.data.prices.data.prepayment` (object)

  - `data.plans.data.prices.data.drawdown` (object)

  - `data.plans.data.prices.data.taxable` (boolean)

  - `data.plans.data.prices.data.price_change_percentage` (number)
    The percentage to increase or decrease the price of a termed subscription's renewal.

  - `data.plans.data.prices.data.price_change_option` (string)
    Applies an automatic price change when a termed subscription is renewed.
    Enum: "latest_catalog_pricing", "percentage", "none"

  - `data.plans.data.prices.data.price_increase_option` (boolean)
    Indicates whether to apply an automatic price change when a termed subscription is renewed.

  - `data.plans.data.prices.data.plan_id` (string)
    Specify the ID of a plan to which this price is associated.

  - `data.plans.data.prices.data.plan_number` (string)
    Specify the number of a plan to which this price is associated. This field is required if plan_id is not supplied

  - `data.plans.data.prices.data.charge_type` (string)
    The type of charge. Can be one_time,recurring, or usage.

  - `data.plans.data.prices.data.charge_model` (string)
    The charge model of the price, which determines how users are charged. Common charge models include flat fee, per-unit, volume, and tiered prices.

  - `data.plans.data.prices.data.tiers_mode` (string)
    Specifies the mode for tiered prices.
    Enum: "graduated", "volume", "high_watermark_volume", "high_watermark_graduated", "graduated_with_overage"

  - `data.plans.data.prices.data.overage` (object)
    An object defining how overage charges are calculated.

  - `data.plans.data.prices.data.active` (boolean)
    Whether the price can be used for new purchases.

## Response 400 fields (application/json):

  - `type` (string)

  - `errors` (array)

  - `errors.code` (string)

  - `errors.parameter` (string)

  - `errors.message` (string)

  - `retryable` (boolean)


